require 'test/unit'
require 'fox14'
require 'testcase'

include Fox

class TC_FXRealSlider < TestCase
  def setup
    super("TC_FXRealSlider")
    @slider = FXRealSlider.new(mainWindow)
  end
  
  def test_command_message_data
    passed = false
    @slider.connect(SEL_COMMAND) { |sender, sel, ptr|
      assert_instance_of(Float, ptr)
      passed = true
    }
    @slider.handle(nil, FXSEL(SEL_COMMAND, FXRealSpinner::ID_ENTRY), nil)
    assert(passed)
  end
  
  def test_changed_message_data
    passed = false
    @slider.connect(SEL_CHANGED) { |sender, sel, ptr|
      assert_instance_of(Float, ptr)
      passed = true
    }
    @slider.value = 1.0
    # how to force a change?
#   @slider.handle(nil, FXSEL(SEL_CHANGED, FXRealSpinner::ID_ENTRY), nil)
    assert(passed)
  end
end
