require 'test/unit'
require 'fox14'
require 'testcase'

include Fox

class TC_FXRealSpinner < TestCase
  def setup
    super("TC_FXRealSpinner")
    @spinner = FXRealSpinner.new(mainWindow, 6)
  end
  
  def test_command_message_data
    passed = false
    @spinner.connect(SEL_COMMAND) { |sender, sel, ptr|
      assert_instance_of(Float, ptr)
      passed = true
    }
    @spinner.handle(nil, FXSEL(SEL_COMMAND, FXRealSpinner::ID_ENTRY), nil)
    assert(passed)
  end
  
  def test_changed_message_data
    passed = false
    @spinner.connect(SEL_CHANGED) { |sender, sel, ptr|
      assert_instance_of(Float, ptr)
      passed = true
    }
    @spinner.value = 1.0
    # how to force a change?
#   @spinner.handle(nil, FXSEL(SEL_CHANGED, FXRealSpinner::ID_ENTRY), nil)
    assert(passed)
  end
end
